import DaliSubprogram

Class JpegXCodeTest -superclass DaliSubprogram

JpegXCodeTest instproc init {args} {
    eval $self next $args;

    $self instvar input_id_list_;
    $self instvar input_info_;

    lappend input_id_list_ i1;

    set input_info_(i1,spec) ""
    set input_info_(i1,trigger) 0;
    set input_info_(i1,buffertype) JPEGCompressed;
    set input_info_(i1,buffername) [new VidRep/JPEGCompressed];
    set input_info_(i1,decoder) "";

    $self instvar output_id_list_;
    $self instvar output_info_;
    
    lappend output_id_list_ o1;
    
    set output_info_(o1,spec) "";
    set output_info_(o1,buffertype) Uncompressed;
    set output_info_(o1,buffername) [new VidRep/Uncompressed];
    set output_info_(o1,encoder) "";
    set output_info_(o1,format) JPEG;
    set output_info_(o1,vagent) "";
    
}

JpegXCodeTest instproc trigger {} {
    $self instvar init_done_;
    $self instvar input_info_;
    $self instvar output_info_;
    $self instvar xcoder_;

    set in_frame $input_info_(i1,buffername);

    if {![info exists init_done_]} {
	if {[$in_frame set w_] == 0} {
	    return;
	}

	set xcoder_ [new Module/VideoXcoder/JPEGCompressedToUncompressed];
	$xcoder_ set_frame_buffer $output_info_(o1,buffername);
	set init_done_ 1;
    }

    $xcoder_ transcode $in_frame;

    set encoder $output_info_(o1,encoder);

    if {$encoder != ""} {
	$encoder recv $output_info_(o1,buffername);
    }
    
    $self send_completion_token;
}

