import RTPApplication
import VideoAgent

Class MyVAgent -superclass VideoAgent

MyVAgent instproc create_decoder {src} {
    set decoder [new Module/VideoDecoder/Null];
    $decoder set agent_ $self;
    $decoder set src_ $src;

    return $decoder;
}

Class PktRec -superclass RTPApplication 

PktRec instproc init args {
    $self next pkt_rec;

    $self init_resources;

    $self instvar vagent_;

    global kpatel_debug;

    set kpatel_debug [new LogService];
    $kpatel_debug on;

    set vagent_ [new MyVAgent $self [$self get_option input_spec]];
}

PktRec instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 2000000
    $self add_option input_spec 224.2.2.4/22334
}
    
set app [new PktRec $argv];

proc SaveLog {fname} {
    global kpatel_debug;

    $kpatel_debug dump $fname;
    $kpatel_debug reset;
}

proc Reset {} {
    global kpatel_debug;

    $kpatel_debug reset;
}    

proc Measure {} {
    global kpatel_debug;

    $kpatel_debug off;
    $kpatel_debug reset;
    $kpatel_debug on;

    after 24000 "global kpatel_debug; $kpatel_debug off; $kpatel_debug dump [glob ~]/tmp/pr-log.txt; puts {Measurement Done}"
}
