import RTPApplication
import TemporalInterleaver

Class TInterApp -superclass RTPApplication

TInterApp instproc init args {
    global kpatel_debug;

    set kpatel_debug [new LogService];
    $kpatel_debug on;

    $self next tinter_app

    $self init_resources;

    [$self options] register_option -comm_id comm_id
    [$self options] register_option -cntrl_spec cntrl_spec
    
    eval [$self options] parse_args $args;

    $self instvar tinter_obj_
    
    set tinter_obj_ [new TemporalInterleaver [$self get_option comm_id] [$self get_option cntrl_spec]];
}

TInterApp instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 30000000
    $self add_option comm_id ti
    $self add_option cntrl_spec 224.3.2.1/22334/16
}

set app [new TInterApp $argv];
puts "Interleaver running on [exec hostname]";
#vwait forever;
